FUNCTION_BLOCK GeneratoreOndaQuadra
  VAR_INPUT
    Input : BOOL;
  END_VAR
  VAR_OUTPUT
    Output : BOOL;
  END_VAR

  INITIAL_STEP Quiete:
  END_STEP

  TRANSITION FROM Quiete TO Onda_On
    := Input;
  END_TRANSITION

  STEP Onda_On:
    Output(N);
  END_STEP

  TRANSITION FROM Onda_On TO Quiete
    := Input;
  END_TRANSITION

  TRANSITION FROM Onda_On TO Onda_Off
    := (Onda_On.T>=T#4s) AND (NOT(Input));
  END_TRANSITION

  STEP Onda_Off:
  END_STEP

  TRANSITION FROM Onda_Off TO Quiete
    := Input;
  END_TRANSITION

  TRANSITION FROM Onda_Off TO Onda_On
    := (Onda_Off.T>=T#6s) AND (NOT(Input));
  END_TRANSITION

END_FUNCTION_BLOCK

PROGRAM Main
  VAR
    IN : BOOL;
    OUT : BOOL;
    OndaQuadra : GeneratoreOndaQuadra;
    F_IN : R_TRIG;
  END_VAR

  F_IN(CLK:=IN);
  OndaQuadra(Input:=F_IN.Q);
  OUT:=OndaQuadra.Output;
END_PROGRAM


CONFIGURATION Config0

  RESOURCE Res0 ON PLC
    TASK CicloDiScansione(INTERVAL := T#100ms,PRIORITY := 0);
    PROGRAM InstanzaMain WITH CicloDiScansione : Main;
  END_RESOURCE
END_CONFIGURATION
